;------------------------------------------------------------------------------
int11		equ	11h*4

code		segment	public
		assume cs:code,ds:code
old_int11	dw	2 dup (?)		;far pointer to old int

;------------------------------------------------------------------------------
;
;   procedure: p_int11
; description: this interrupt routine is wired to the timer interrupt.  
;		18.2 times a second this puppy fires.  Each tick we 
;		decrement our count.  If it is goes to 0 we save the contents
;		of the screen and blank it.
;------------------------------------------------------------------------------
p_int11		proc	far

blastoff:	pushf
		call	dword ptr cs:old_int11
		and	ax, not 2		;mask bit 2 (coprocessor)
		iret
p_int11		endp

end_of_prog	label	byte

;------------------------------------------------------------------------------
; Everything after this point is gone after the program TSR's
;------------------------------------------------------------------------------
main		proc	far
		mov	ax,cs
		mov	ds,ax

	;-- Set ES to the interrupt vector to the bios

install_me:	xor	ax,ax
		mov	es,ax		;point es to the interrup seg.

	;--- get the original interrupt vectors.

		mov	ax,es:[int11]
		mov	old_int11,ax
		mov	ax,es:[int11][2]
		mov	old_int11[2],ax

	;--- set them to the new routines.
	
		cli				
		mov	word ptr es:[int11],offset p_int11
		mov	es:[int11][2],cs
		sti

	;--- and TSR.

		mov	dx,offset end_of_prog
		add	dx,15
		shr	dx,1
		shr	dx,1
		shr	dx,1
		shr	dx,1
		add	dx,10h		;10 paragraphs for PSP
		mov	ah,31h
		int	21h

main		endp
code		ends
end 		main
